-- p22.py - MHS88  P2 definitions


-- @(#) $Header: /cs/research/pp/hubris/pp-beta/Tools/mpp88/RCS/p2.py,v 5.0 90/09/20 16:28:42 pp Exp Locker: pp $
--
-- $Log:	p2.py,v $
-- Revision 5.0  90/09/20  16:28:42  pp
-- rcsforce : 5.0 public release
-- 
--



P22 {joint-iso-ccitt mhs-motis(6) ipms(1) modules(0) information-objects(2)}
DEFINITIONS IMPLICIT TAGS ::=
BEGIN

IMPORTS
	EncodedInformationTypes, G3FacsimileNonBasicParameters,
	MessageDeliveryTime, ORAddress, ORName,
	OtherMessageDeliveryFields, SupplementaryInformation,
	TeletexNonBasicParameters
	FROM MTA {joint-iso-ccitt mhs-motis(6) mts(3) modules(0) mTS-abstract-service(1)};

Time ::= UTCTime

-- Information object

InformationObject ::= CHOICE {
	ipm [0] IPM,
	ipn [1] IPN}

-- IPM

IPM ::= SEQUENCE {
	heading Heading,
	body    Body}

-- Heading

Heading ::= SET {
	this-IPM                  IPMIdentifier,
	originator            [0] OriginatorField OPTIONAL,
	authorizing-users     [1] AuthorizingUsersField OPTIONAL,
	primary-recipients    [2] PrimaryRecipientsField DEFAULT {},
	copy-recipients       [3] CopyRecipientsField DEFAULT {},
	blind-copy-recipients [4] BlindCopyRecipientsField OPTIONAL,
	replied-to-IPM        [5] RepliedToIPMField OPTIONAL,
	obsoleted-IPMs        [6] ObsoletedIPMsField DEFAULT {},
	related-IPMs          [7] RelatedIPMsField DEFAULT {},
	subject               [8] EXPLICIT SubjectField OPTIONAL,
	expiry-time           [9] ExpiryTimeField OPTIONAL,
	reply-time           [10] ReplyTimeField OPTIONAL,
	reply-recipients     [11] ReplyRecipientsField OPTIONAL,
	importance           [12] ImportanceField DEFAULT normal,
	sensitivity          [13] SensitivityField OPTIONAL,
	auto-forwarded       [14] AutoForwardedField DEFAULT FALSE,
	extensions           [15] ExtensionsField DEFAULT {}}

-- Heading component types

IPMIdentifier ::= [APPLICATION 11] SET {
	user                     [APPLICATION 0] ORName OPTIONAL,
	user-relative-identifier LocalIPMIdentifier}

LocalIPMIdentifier ::= PrintableString
	(SIZE (0..ub-local-ipm-identifier))

RecipientSpecifier ::= SET {
	recipient             [0] ORDescriptor,
	notification-requests [1] NotificationRequests DEFAULT {},
	reply-requested       [2] BOOLEAN DEFAULT FALSE}

NotificationRequests ::= BIT STRING {
	rn(0),
	nrn(1),
	ipm-return(2)}

ORDescriptor ::= SET {
	formal-name	 [APPLICATION 0] ORName OPTIONAL,
	free-form-name   [0] FreeFormName OPTIONAL,
	telephone-number [1] TelephoneNumber OPTIONAL}

FreeFormName ::= TeletexString (SIZE (0..ub-free-form-name))

TelephoneNumber ::= PrintableString (SIZE (0..ub-telephone-number))

-- This IPM heading field

ThisIPMField ::= IPMIdentifier

-- Originator heading field

OriginatorField ::= ORDescriptor

-- Authorizing Users heading field

AuthorizingUsersField    ::= SEQUENCE OF AuthorizingUsersSubfield

AuthorizingUsersSubfield ::= ORDescriptor

-- Primary Recipients heading field

PrimaryRecipientsField    ::= SEQUENCE OF PrimaryRecipientsSubfield

PrimaryRecipientsSubfield ::= RecipientSpecifier

-- Copy Recipients heading field

CopyRecipientsField    ::= SEQUENCE OF CopyRecipientsSubfield

CopyRecipientsSubfield ::= RecipientSpecifier

-- Blind Copy Recipients heading field

BlindCopyRecipientsField    ::= SEQUENCE OF BlindCopyRecipientsSubfield

BlindCopyRecipientsSubfield ::= RecipientSpecifier

-- Replied-to IPM heading field

RepliedToIPMField ::= IPMIdentifier

-- Obsoleted IPMs heading field

ObsoletedIPMsField    ::= SEQUENCE OF ObsoletedIPMsSubfield

ObsoletedIPMsSubfield ::= IPMIdentifier

-- Related IPMs heading field

RelatedIPMsField    ::= SEQUENCE OF RelatedIPMsSubfield

RelatedIPMsSubfield ::= IPMIdentifier

-- Subject heading field

SubjectField ::= TeletexString (SIZE (0..ub-subject-field))

-- Expiry Time heading field

ExpiryTimeField ::= Time

-- Reply Time heading field

ReplyTimeField ::= Time

-- Reply Recipients heading field

ReplyRecipientsField    ::= SEQUENCE OF ReplyRecipientsSubfield

ReplyRecipientsSubfield ::= ORDescriptor

-- Importance heading field

ImportanceField ::= ENUMERATED {
	low   (0),
	normal(1),
	high  (2)}

-- Sensitivity heading field

SensitivityField ::= ENUMERATED {
	personal            (1),
	private             (2),
	company-confidential(3)}

-- Auto-forwarded heading field

AutoForwardedField ::= BOOLEAN

-- Extensions heading field

ExtensionsField ::= SET OF HeadingExtension

HeadingExtension ::= SEQUENCE {
	type  OBJECT IDENTIFIER,
	value ANY DEFINED BY type DEFAULT NULL NULL}

-- Body

Body ::= SEQUENCE OF BodyPart

BodyPart ::= CHOICE {
	ia5-text             [0] IA5TextBodyPart,
	voice                [2] VoiceBodyPart,
	g3-facsimile         [3] G3FacsimileBodyPart,
	g4-class1            [4] G4Class1BodyPart,
	teletex              [5] TeletexBodyPart,
	videotex             [6] VideotexBodyPart,
	nationally-defined   [7] NationallyDefinedBodyPart,
	encrypted            [8] EncryptedBodyPart,
	message              [9] MessageBodyPart,
	mixed-mode          [11] MixedModeBodyPart,
	bilaterally-defined [14] BilaterallyDefinedBodyPart,
	externally-defined  [15] ExternallyDefinedBodyPart}

-- IA5 Text body part

IA5TextBodyPart ::= SEQUENCE {
	parameters IA5TextParameters,
	data       IA5TextData}

IA5TextParameters ::= SET {
	repertoire [0] Repertoire DEFAULT ia5}

IA5TextData ::= IA5String

Repertoire ::= ENUMERATED {
	ita2(2),
	ia5 (5)}

-- Voice body part

VoiceBodyPart ::= ANY

-- G3 Facsimile body part

G3FacsimileBodyPart ::= SEQUENCE {
	parameters G3FacsimileParameters,
	data       G3FacsimileData}

G3FacsimileParameters ::= SET {
	number-of-pages      [0] INTEGER DEFAULT 0,
	non-basic-parameters [1] G3FacsimileNonBasicParameters OPTIONAL}

G3FacsimileData ::= SEQUENCE OF BIT STRING

-- G4 Class 1 and Mixed-mode body parts

G4Class1BodyPart  ::= SEQUENCE OF ProtocolElement

MixedModeBodyPart ::= SEQUENCE OF ProtocolElement

ProtocolElement ::= ANY

-- Teletex body part

TeletexBodyPart ::= SEQUENCE {
	parameters TeletexParameters,
	data       TeletexData}

TeletexParameters ::= SET {
	number-of-pages      [0] INTEGER DEFAULT 0,
	telex-compatible     [1] BOOLEAN DEFAULT FALSE,
	non-basic-parameters [2] TeletexNonBasicParameters OPTIONAL}

TeletexData ::= SEQUENCE OF TeletexString

-- Videotex body part

VideotexBodyPart ::= SEQUENCE {
	parameters VideotexParameters,
	data       VideotexData}

VideotexParameters ::= SET {
	syntax [0] VideotexSyntax OPTIONAL}

VideotexSyntax ::= INTEGER {
	ids         (0),
	data-syntax1(1),
	data-syntax2(2),
	data-syntax3(3)}

VideotexData ::= VideotexString

-- Encrypted body part

EncryptedBodyPart ::= SEQUENCE {
	parameters EncryptedParameters,
	data       EncryptedData}

EncryptedParameters ::= ANY -- for [further study|future standardization]
EncryptedData ::= BIT STRING -- for [further study|future standardization]

-- Message body part

MessageBodyPart ::= SEQUENCE {
	parameters MessageParameters,
	data       MessageData}

MessageParameters ::= SET {
	delivery-time     [0] MessageDeliveryTime OPTIONAL,
	delivery-envelope [1] OtherMessageDeliveryFields OPTIONAL}

MessageData ::= IPM

-- Bilaterally Defined body part

BilaterallyDefinedBodyPart ::= OCTET STRING

-- Nationally Defined body part

NationallyDefinedBodyPart ::= ANY

-- Externally Defined body part

ExternallyDefinedBodyPart ::= SEQUENCE {
	parameters ExternallyDefinedParameters,
	data       ExternallyDefinedData}

ExternallyDefinedParameters ::= ExternalType
	
ExternallyDefinedData ::= ExternalType

ExternalType ::= [UNIVERSAL 8] IMPLICIT SEQUENCE {
	direct-reference	OBJECT IDENTIFIER OPTIONAL,
	indirect-reference	INTEGER DEFAULT 0,
	encoding		[0] ANY}

-- IPN

IPN ::= SET {
		subject-ipm                 SubjectIPMField,
		ipn-originator          [1] IPNOriginatorField OPTIONAL,
		ipm-preferred-recipient	[2] IPMPreferredRecipientField OPTIONAL
,
		conversion-eits             EncodedInformationTypes OPTIONAL,
		non-receipt-fields	[0] NonReceiptFields OPTIONAL,
		receipt-fields 		[3] ReceiptFields OPTIONAL}

RN ::= IPN -- with receipt-fields chosen

NRN ::= IPN -- with non-receipt-fields chosen

CommonFields ::= SET {
	subject-ipm                 SubjectIPMField,
	ipn-originator          [1] IPNOriginatorField OPTIONAL,
	ipm-preferred-recipient [2] IPMPreferredRecipientField OPTIONAL,
	conversion-eits             EncodedInformationTypes OPTIONAL}

NonReceiptFields ::= SET {
	non-receipt-reason   [0] NonReceiptReasonField,
	discard-reason       [1] DiscardReasonField OPTIONAL,
	auto-forward-comment [2] AutoForwardCommentField OPTIONAL,
	returned-ipm         [3] ReturnedIPMField OPTIONAL}

ReceiptFields ::= SET {
	receipt-time        [0] ReceiptTimeField,
	acknowledgment-mode [1] AcknowledgmentModeField DEFAULT manual,
	suppl-receipt-info  [2] SupplementaryInformation DEFAULT ""}

-- Common fields

SubjectIPMField ::= IPMIdentifier

IPNOriginatorField ::= ORDescriptor

IPMPreferredRecipientField ::= ORDescriptor

-- Non-receipt fields

NonReceiptReasonField ::= ENUMERATED {
	ipm-discarded     (0),
	ipm-auto-forwarded(1)}

DiscardReasonField ::= ENUMERATED {
	ipm-expired                 (0),
	ipm-obsoleted               (1),
	user-subscription-terminated(2)}

AutoForwardCommentField ::= AutoForwardComment

AutoForwardComment ::= PrintableString
	(SIZE (0..ub-auto-forward-comment))

ReturnedIPMField ::= IPM

-- Receipt fields

ReceiptTimeField ::= Time

AcknowledgmentModeField ::= ENUMERATED {
	manual   (0),
	automatic(1)}

SupplReceiptInfoField ::= SupplementaryInformation

-- Message Store Realization

ForwardedInfo ::= SET {
	auto-forwarding-comment [0] AutoForwardComment OPTIONAL,
	cover-note [1] IA5TextBodyPart OPTIONAL,
	this-ipm-prefix [2] PrintableString (SIZE
		(1..ub-ipm-identifier-suffix)) OPTIONAL}

END -- of IPMSInformationObjects
