This file describes the various macros you will need to define for Make.defs
See volume 1 of the PP user guide for more details.

BINDIR		= /usr/lib/pp/bin
administrator binaries - no user program found here.

CMDDIR		= /usr/lib/pp/cmds
PP main programs

CHANDIR		= $(CMDDIR)/chans
PP channel programs

CMDFM		= $(CMDDIR)/format
PP formatting channels run under fcontrol

MACDIR		= $(CMDDIR)/macros
Miscellaneous macro commands

LOGDIR		= /usr/lib/pp/logs
Where the log files should be placed

MANDIR		= /usr/local/man
where the manual pages should go
MANOPTS		 = -bsd
Manual page installation options

TAILOR		= /usr/lib/pp/tailor
The tailor file. This file is critical.

QUEDIR		= /usr/lib/pp/spool/queues
Where the PP disc queue is kept - needs plenty of headroom

TBLDIR		= /usr/lib/pp/tables
Where the routing tables etc go.

USRBINDIR	= /usr/local/bin
Where user visible binaries should be placed.

# Other Libraries and programs
LIBSYS		= -lisode
System installed libraries. -ldbm may be useful

OPTIONALCHANS	= list local shell smtp uucp x40084
The particular channels that you require building.

PEPY		= pepy
PYFLAGS		=
ISODE pepy program and any global flags

ROSY		= rosy
RYFLAGS		=
ISODE rosy program and any global flags

POSY		= posy
POFLAGS		=
ISODE posy program and any global flags

LINTISODE	= -lisode
The ISODE lint library if needed. Only useful if you wish to lint the
PP sources

X11		= true
Set to "true" if you have X11, leave empty otherwise

LIBX		= -lXaw -lXmu -lXt -lX11 
The X11 libraries you will need.

LIBRESOLV	=
The name of the BIND resolver library. You will need to define
NAMESERVER if you want to use this.

CC		= cc
The C compiler

CCOPTIONS	= -O
Compiler options

LIBCCOPTIONS	= -O
Compiler options for just the libraries.

LDOPTIONS	=
Any loader options needed

AR		= ar
The archiver program

ARFLAGS		=
Archiver flags

RANLIB		= ranlib
The ranlib program if you need it

LINT		= lint
The lint program

LINTFLAGS	= -haxbc
The lint flags in force

PGMPROT		= 755
The mode for general binaries to be installed with

PPUSER		= pp
The User which will own the PP system

ROOTUSER	= root
The root user - needed for setuid channels

CHOWN		= chown
man 8 chown command

CHMOD		= chmod
man 1 chmod command

BACKUP		= cp
What to use to save backup copies - set to : if you don't want any

INSTALL		= cp
# what to use to install new binaries etc. install(1) is also suitable

