/* extension.h: extension attributes */

/*
 * @(#) $Header: /cs/research/pp/hubris/pp-beta/h/RCS/extension.h,v 5.0 90/09/20 16:50:16 pp Exp Locker: pp $
 *
 * $Log:	extension.h,v $
 * Revision 5.0  90/09/20  16:50:16  pp
 * rcsforce : 5.0 public release
 * 
 *
 */



#ifndef _H_EXTENSION
#define _H_EXTENSION


#include <isode/psap.h>

typedef struct mt_extension {
	int ext_int;
#define EXT_OID_FORM 	-1
	OID	ext_oid;
	struct qbuf *ext_value;
	int ext_criticality;
	struct mt_extension *ext_next;
} Extension;

extern void extensions_free ();

#define CRITICAL_NONE		0
#define CRITICAL_SUBMISSION 	0x1
#define CRITICAL_TRANSFER 	0x2
#define CRITICAL_DELIVERY 	0x4


#define	EXT_RECIPIENT_REASSIGNMENT_PROHIBITED		1
#define	EXT_RECIPIENT_REASSIGNMENT_PROHIBITED_DC	CRITICAL_DELIVERY
#define EXT_ORIGINATOR_REQUESTED_ALTERNATE_RECIPIENT	2
#define EXT_ORIGINATOR_REQUESTED_ALTERNATE_RECIPIENT_DC	CRITICAL_NONE
#define EXT_DL_EXPANSION_PROHIBITED			3
#define EXT_DL_EXPANSION_PROHIBITED_DC			CRITICAL_DELIVERY
#define EXT_CONVERSION_WITH_LOSS_PROHIBITED		4
#define EXT_CONVERSION_WITH_LOSS_PROHIBITED_DC		CRITICAL_DELIVERY
#define EXT_LATEST_DELIVERY_TIME			5
#define EXT_LATEST_DELIVERY_TIME_DC			CRITICAL_DELIVERY
#define EXT_REQUESTED_DELIVERY_METHOD			6
#define EXT_REQUESTED_DELIVERY_METHOD_DC		CRITICAL_DELIVERY
#define EXT_PHYSICAL_FORWARDING_PROHIBITED		7
#define EXT_PHYSICAL_FORWARDING_PROHIBITED_DC		CRITICAL_DELIVERY
#define EXT_PHYSICAL_FORWARDING_ADDRESS_REQUEST		8
#define EXT_PHYSICAL_FORWARDING_ADDRESS_REQUEST_DC	CRITICAL_DELIVERY
#define EXT_PHYSICAL_DELIVERY_MODES			9
#define EXT_PHYSICAL_DELIVERY_MODES_DC			CRITICAL_DELIVERY
#define EXT_REGISTERED_MAIL				10
#define EXT_REGISTERED_MAIL_DC				CRITICAL_DELIVERY
#define EXT_RECIPIENT_NUMBER_FOR_ADVICE			11
#define EXT_RECIPIENT_NUMBER_FOR_ADVICE_DC		CRITICAL_DELIVERY
#define EXT_PHYSICAL_RENDITION_ATTRIBUTES		12
#define EXT_PHYSICAL_RENDITION_ATTRIBUTES_DC		CRITICAL_DELIVERY
#define EXT_ORIGINATOR_RETURN_ADDRESS			13
#define EXT_ORIGINATOR_RETURN_ADDRESS_DC		CRITICAL_DELIVERY
#define EXT_PHYSICAL_DELIVERY_REPORT_REQUEST		14
#define EXT_PHYSICAL_DELIVERY_REPORT_REQUEST_DC		CRITICAL_DELIVERY
#define EXT_ORIGINATOR_CERTIFICATE			15
#define EXT_ORIGINATOR_CERTIFICATE_DC			CRITICAL_DELIVERY
#define EXT_MESSAGE_TOKEN				16
#define EXT_MESSAGE_TOKEN_DC				CRITICAL_NONE
#define EXT_CONTENT_CONFIDENTIALITY_ALGORITHM_IDENTIFIER 17
#define EXT_CONTENT_CONFIDENTIALITY_ALGORITHM_IDENTIFIER_DC CRITICAL_NONE
#define EXT_CONTENT_INTEGRITY_CHECK			18
#define EXT_CONTENT_INTEGRITY_CHECK_DC			CRITICAL_NONE
#define EXT_MESSAGE_ORIGIN_AUTHENTICATION_CHECK		19
#define EXT_MESSAGE_ORIGIN_AUTHENTICATION_CHECK_DC	CRITICAL_DELIVERY
#define EXT_MESSAGE_SECURITY_LABEL			20
#define EXT_MESSAGE_SECURITY_LABEL_DC			CRITICAL_DELIVERY
#define EXT_PROOF_OF_SUBMISSION_REQUEST			21
#define EXT_PROOF_OF_SUBMISSION_REQUEST_DC		CRITICAL_SUBMISSION
#define EXT_FORWARDING_REQUEST				36
#define EXT_FORWARDING_REQUEST_DC			CRITICAL_SUBMISSION
#define EXT_PROOF_OF_DELIVERY_REQUEST			22
#define EXT_PROOF_OF_DELIVERY_REQUEST_DC		CRITICAL_DELIVERY
#define EXT_CONTENT_CORRELATOR				23
#define EXT_CONTENT_CORRELATOR_DC			CRITICAL_NONE
#define EXT_PROBE_ORIGIN_AUTHENTICATION_CHECK		24
#define EXT_PROBE_ORIGIN_AUTHENTICATION_CHECK_DC	CRITICAL_DELIVERY
#define EXT_REDIRECTION_HISTORY				25
#define EXT_REDIRECTION_HISTORY_DC			CRITICAL_NONE
#define EXT_DL_EXPANSION_HISTORY			26
#define EXT_DL_EXPANSION_HISTORY_DC			CRITICAL_NONE
#define EXT_PHYSICAL_FORWARDING_ADDRESS			27
#define EXT_PHYSICAL_FORWARDING_ADDRESS_DC		CRITICAL_NONE
#define EXT_RECIPIENT_CERTIFICATE			28
#define EXT_RECIPIENT_CERTIFICATE_DC			CRITICAL_NONE
#define EXT_PROOF_OF_DELIVERY				29
#define EXT_PROOF_OF_DELIVERY_DC			CRITICAL_NONE
#define EXT_ORIGINATOR_AND_DL_EXPANSION_HISTORY		30
#define EXT_ORIGINATOR_AND_DL_EXPANSION_HISTORY_DC	CRITICAL_NONE
#define EXT_REPORT_DL_NAME				31
#define EXT_REPORT_DL_NAME_DC				CRITICAL_NONE
#define EXT_REPORTING_MTA_CERTIFICATE			32
#define EXT_REPORTING_MTA_CERTIFICATE_DC		CRITICAL_DELIVERY
#define EXT_REPORT_ORIGIN_AUTHENTICATION_CHECK		33
#define EXT_REPORT_ORIGIN_AUTHENTICATION_CHECK_DC	CRITICAL_DELIVERY
#define EXT_ORIGINATING_MTA_CERTIFICATE			34
#define EXT_ORIGINATING_MTA_CERTIFICATE_DC		CRITICAL_NONE
#define EXT_PROOF_OF_SUBMISSION				35
#define EXT_PROOF_OF_SUBMISSION_DC			CRITICAL_NONE
#define EXT_INTERNAL_TRACE_INFORMATION			38
#define EXT_INTERNAL_TRACE_INFORMATION_DC		CRITICAL_NONE


#endif
